Doomsday Engine - Bug #2082

External music (WAV and MP3 formats) are not played; custom music definitions vs.
"MAPnNnn_music"

2015-06-08 02:43 - theleo_ua

Status: Closed Start date: 2015-06-08
Priority: Normal % Done: 100%
Assignee: skyjake

Category: Regression

Target version: 2.1 (Late 2018)

Description

external music in wave format cannot be played with fmod

Steps to reproduce:

1) Select "music source = external files" in ingame options and "sound driver = fmod" in snowberry
2) Place WINNOWR.ogg in data/jhexen/music folder

3) Run (or restart) hexen, start map1 and see that external music works correctly

4) repeat steps 1-3 with WAV music version (WINNOWR.wav)

Actual result: midi source is used instead of external wav source
Expected result: external wav source should be used

5) repeat step 4 with MP3 version

Actual result: noise is played instead of music
Expected result: mp3 music should be played

NOTE: | tried to extract "music.ded" from libhexen.pk3 and add strings like
Music { ID = "winnowr"; Lump = "WINNOWR"; Ext = "Data\jHexen\Music\WINNOWR.wav"; }
to it, but result is same - midi music source is used

NOTEZ2: please change version to 1.15.0 (I dont see such option for me)

Associated revisions

Revision f9565d40 - 2018-11-24 20:35 - skyjake

Fixed|Music: Defined external music file ignored

The way Hexen loads the MAPINFO and SNDINFO lumps was causing custom music definitions to be ignored.

The MAPINFO translator (that generates corresponding DEDs) was adding music definitions that would be used even when custom music was
loaded. Now these generated definitions are only present when parsing custom MAPINFO data. (Non-custom map infos are expected to have a

music definition available matching the map ID.)

In Hexen, SNDINFO is applied by default so that if a matching music definition is available (by ID), the map info is changed to use that music (that
may be a custom music definition).

IssuelD #2082
Revision ef8e5bcc - 2018-11-24 21:14 - skyjake
Fixed|Music|Definitions: Music pack compatibility issues

Make sure Music defs overwrite contents from the earlier ones. Music IDs can't be fully trusted because music definitions are sometimes generated
by idtech1importer, so they might have IDs that don't match the vanilla IDs.

Fixes compatibility problems with older music packs.

IssuelD #2082

History
#1 - 2015-06-08 03:18 - theleo_ua

NOTE2: please change version to 1.15.0 (I dont see such option for me)

my misunderstanding:) 1.15.1 is correct value for "target version", sorry about this

#2 - 2015-06-13 10:01 - skyjake
- Target version deleted (1.15.1)

#3 - 2015-11-25 22:26 - skyjake
- Assignee deleted (skyjake)

#4 - 2017-04-03 13:45 - skyjake
- Tags set to Music

- Subject changed from external music in wave and mp3 formats cannot be played with fmod to External music in WAV and MP3 formats cannot be
played with FMOD

- Priority changed from Lowest to Normal

- Target version set to 2.1 (Late 2018)

#5 - 2018-11-24 18:22 - skyjake

- Subject changed from External music in WAV and MP3 formats cannot be played with FMOD to External music (WAV and MP3 formats) are not
played; custom music definitions vs. "MAPnn_music"

- Assignee set to skyjake

| tested WAV and MP3 with the latest unstable 2.1, and from an audio standpoint there is now no problem playing back the files with FMOD.

MP3 files are detected as lump replacements and will be played from Data\jHexen\Music automatically, without needing any definitions. WAV is not
recognized in this fashion (by design).

However, there is an unfortunate regression in the way MAPINFO is handled. Custom music definitions that define external file paths are being
ignored because Doomsday now generates music definitions using the pattern "MAPnn_music", while the previous assumption has been that the
music definitions are 1D'd according to the music lumps. The Ext paths will be ignored because they have no relation to the "MAPnn_music"
definitions.

This needs some rethinking. Custom music definitions should continue to use the lump name IDs (e.g., "winnowr") and Doomsday should also use
these IDs when generating its internal music defs. However, care must be taken that the user's custom DEDs are processed/loaded after the internal
definitions.

#6 - 2018-11-24 20:37 - skyjake
- Status changed from New to Resolved

- % Done changed from 0 to 100

Applied a fix, although the processing of MAPINFO and SNDINFO with regard to DED definitions feels bug-prone. This still needs
rethinking/simplification at a later time.

#7 - 2018-12-06 12:14 - skyjake

- Status changed from Resolved to Closed
